Program CycleGad_Test;

{$I "include:intuition/intuition.i"}
{$I "include:utils/Cyclegad.i"}

CONST

   StdInName : Address = Nil;
   StdOutName: Address = Nil;

   STDFont : textAttr = ("topaz.font",8,FS_NORMAL,FPF_ROMFONT);

   win : newwindow = (0,0,220,65,-1,-1,GADGETDOWN_f + CLOSEWINDOW_f,
                      WINDOWDRAG + WINDOWDEPTH + WINDOWCLOSE + ACTIVATE,
                      nil,nil,"Test de CycleGad",nil,nil,-1,-1,-1,-1,
                      WBENCHSCREEN_f);

   CGPairs1 :array[1..3,1..2] of short = ((0,13),(0,0),(127,0));
   CGPairs2 :array[1..3,1..2] of short = ((1,12),(1,0),(127,0));
   CGPairs3 :array[1..3,1..2] of short = ((1,13),(128,13),(128,0));
   CGPairs4 :array[1..3,1..2] of short = ((1,13),(127,13),(127,1));

{ Notez : les dernires structures pointent sur '@CycleBord1' pour avoir une
 flche }
   CGBorder4 : border = (0,0,1,0,JAM2,3,@CGpairs4,@CycleBord1);
   CGBorder3 : border = (0,0,1,0,JAM2,3,@CGpairs3,@CGBorder4);
   CGBorder2 : border = (0,0,2,0,JAM2,3,@CGpairs2,@CGBorder3);
   CGBorder1 : border = (0,0,2,0,JAM2,3,@CGpairs1,@CGBorder2);

   CGBorderHL4 : border = (0,0,2,0,JAM2,3,@CGpairs4,@CycleBord1);
   CGBorderHL3 : border = (0,0,2,0,JAM2,3,@CGpairs3,@CGBorderHL4);
   CGBorderHL2 : border = (0,0,1,0,JAM2,3,@CGpairs2,@CGBorderHL3);
   CGBorderHL1 : border = (0,0,1,0,JAM2,3,@CGpairs1,@CGBorderHL2);

   CGText1 : intuitext = (1,0,JAM2,22,3,@STDFont,"Aller au 1er",nil);
   CGText2 : intuitext = (1,0,JAM2,22,3,@STDFont,"Aller au 2me",nil);
   CGText3 : intuitext = (1,0,JAM2,22,3,@STDFont,"Aller au 3me",nil);
   CGText4 : intuitext = (1,0,JAM2,22,3,@STDFont,"Aller au 4me",nil);
   CGText5 : intuitext = (1,0,JAM2,22,3,@STDFont,"Aller au 5me",nil);
   CGText6 : intuitext = (1,0,JAM2,22,3,@STDFont,"Aller au 6me",nil);
   CGText7 : intuitext = (1,0,JAM2,22,3,@STDFont,"Aller au 7me",nil);
   CGText8 : intuitext = (1,0,JAM2,22,3,@STDFont,"Aller au 8me",nil);
   CGText9 : intuitext = (1,0,JAM2,22,3,@STDFont,"Aller au 9me",nil);

{Dfinition de la liste}
   CGData9 : CycleGad_Text = (@CGText9,9,nil);
   CGData8 : CycleGad_Text = (@CGText8,8,@CGData9);
   CGData7 : CycleGad_Text = (@CGText7,7,@CGData8);
   CGData6 : CycleGad_Text = (@CGText6,6,@CGData7);
   CGData5 : CycleGad_Text = (@CGText5,5,@CGData6);
   CGData4 : CycleGad_Text = (@CGText4,4,@CGData5);
   CGData3 : CycleGad_Text = (@CGText3,3,@CGData4);
   CGData2 : CycleGad_Text = (@CGText2,2,@CGData3);
   CGData1 : CycleGad_Text = (@CGText1,1,@CGData2);

   CGGad1 : gadget = (nil,15,15,129,14,GADGHIMAGE,RELVERIFY+GADGIMMEDIATE,
                 BOOLGADGET,@CGborder1,@CGborderHL1,@CGText1,0,nil,1,@CGData1);

   CGGad2 : gadget = (nil,15,45,129,14,GADGHIMAGE,RELVERIFY+GADGIMMEDIATE,
                 BOOLGADGET,@CGborder1,@CGborderHL1,@CGText1,0,nil,2,@CGData1);


   GadPairs1 :array[1..3,1..2] of short = ((0,13),(0,0),(51,0));
   GadPairs2 :array[1..3,1..2] of short = ((1,12),(1,0),(51,0));
   GadPairs3 :array[1..3,1..2] of short = ((1,13),(52,13),(52,0));
   GadPairs4 :array[1..3,1..2] of short = ((1,13),(51,13),(51,1));

   GadBorder4 : border = (0,0,1,0,JAM2,3,@Gadpairs4,nil);
   GadBorder3 : border = (0,0,1,0,JAM2,3,@Gadpairs3,@GadBorder4);
   GadBorder2 : border = (0,0,2,0,JAM2,3,@Gadpairs2,@GadBorder3);
   GadBorder1 : border = (0,0,2,0,JAM2,3,@Gadpairs1,@GadBorder2);

   GadBorderHL4 : border = (0,0,2,0,JAM2,3,@Gadpairs4,nil);
   GadBorderHL3 : border = (0,0,2,0,JAM2,3,@Gadpairs3,@GadBorderHL4);
   GadBorderHL2 : border = (0,0,1,0,JAM2,3,@Gadpairs2,@GadBorderHL3);
   GadBorderHL1 : border = (0,0,1,0,JAM2,3,@Gadpairs1,@GadBorderHL2);

   GadText : intuitext = (1,0,JAM2,6,3,@STDFont,"Faire",nil);

   Gad1 : gadget = (nil,153,15,53,14,GADGHIMAGE,RELVERIFY+GADGIMMEDIATE,
                    BOOLGADGET,@GadBorder1,@GadBorderHL1,@GadText,0,nil,3,
                    nil);

   Gad2 : gadget = (nil,153,45,53,14,GADGHIMAGE,RELVERIFY+GADGIMMEDIATE,
                    BOOLGADGET,@GadBorder1,@GadBorderHL1,@GadText,0,nil,4,
                    nil);

VAR
   w    : windowptr;
   Msg  : IntuiMessagePtr;
   Quit : Boolean;

PROCEDURE Ouvre_Tout;

BEGIN

   w := OpenWindow(@Win);
   IF w=nil THEN
      exit(10);

{On complte la liste}
   CGData9.next := @CGData1;

   IF AddGadget(w,@CGGad1,-1)=0 THEN;
   IF AddGadget(w,@CGGad2,-1)=0 THEN;
   IF AddGadget(w,@Gad1,-1)=0 THEN;
   IF AddGadget(w,@Gad2,-1)=0 THEN;

   refreshgadgets(w^.firstgadget,w,nil);

END;

BEGIN

   Ouvre_Tout;
   Quit := false;

   repeat

      Msg := IntuiMessagePtr(WaitPort(w^.UserPort));
      Msg := IntuiMessagePtr(GetMsg(w^.UserPort));

      IF Msg^.Class = CLOSEWINDOW_f THEN
         Quit := TRUE
      ELSE
         CASE GadgetPtr(Msg^.IAddress)^.GadgetId OF

            1  :  CG_CycleText(CGGad1,w);

            2  :  CG_CycleText(CGGad2,w);

            3  :  CG_ChangeTo(CGGad2,w,CG_GetId(CGGad1));

            4  :  CG_ChangeTo(CGGad1,w,CG_GetId(CGGad2));

         END;

      ReplyMsg(MessagePtr(Msg));

   UNTIL Quit;

   CloseWindow(w);

END.
