EXTERNAL;

{$I "include:intuition/intuition.i"}

TYPE

      CycleGad_Text = RECORD
            Text       : intuitextptr;
            Identifier : integer;
            next       : ^CycleGad_Text;
      END;

      CycleGad_TextPtr = ^CycleGad_Text;

PROCEDURE CG_CycleText(VAR gad : gadget;w : windowptr);

VAR
   blt : intuitext;

   PROCEDURE change;
   BEGIN
      blt.frontpen := gad.gadgettext^.backpen;
      blt.backpen  := gad.gadgettext^.backpen;
   END;

   PROCEDURE inverse;
   BEGIN
      blt.frontpen := gad.gadgettext^.backpen;
      blt.backpen := gad.gadgettext^.frontpen;
   END;

BEGIN
   blt := intuitext(gad.gadgettext);

   IF blt.drawmode = INVERSVID THEN
      inverse
   ELSE
      change;

   printitext(w^.rport,@blt,gad.LeftEdge,gad.TopEdge);

   gad.UserData := CycleGad_Textptr(gad.userdata)^.next;
   gad.GadgetText := CycleGad_Textptr(gad.userdata)^.Text;
   refreshgadgets(@gad,w,nil);
END;

FUNCTION CG_GetId(gad : gadget) : integer;

BEGIN
   CG_GetId := CycleGad_Textptr(gad.UserData)^.identifier;
END;

PROCEDURE CG_ChangeTo(VAR Gad : gadget;w : windowptr;Id : integer);

VAR
   blt : intuitext;

   PROCEDURE change;
   BEGIN
      blt.frontpen := gad.gadgettext^.backpen;
      blt.backpen := gad.gadgettext^.backpen;
   END;

   PROCEDURE inverse;
   BEGIN
      blt.frontpen := gad.gadgettext^.backpen;
      blt.backpen := gad.gadgettext^.frontpen;
   END;

BEGIN

   blt := intuitext(gad.gadgettext);

   IF blt.drawmode = INVERSVID THEN
      inverse
   ELSE
      change;

   printitext(w^.rport,@blt,gad.LeftEdge,gad.TopEdge);
   WHILE CycleGad_Textptr(gad.userdata)^.identifier<>Id DO
      gad.UserData := CycleGad_Textptr(gad.userdata)^.next;
   gad.GadgetText := CycleGad_Textptr(gad.userdata)^.Text;
   refreshgadgets(@gad,w,nil);
END;
