PROGRAM BorderMaker;

{$I "include:intuition/intuition.i"}
{$I "include:utils/stringlib.i"}
{$I "include:utils/CycleGad.i"}
{$I "include:libraries/dos.i"}

CONST

      STDFont : textAttr = ("topaz.font",8,FS_NORMAL,FPF_ROMFONT);
      UDRFont : textattr = ("topaz.font",8,FSF_UNDERLINED,FPF_ROMFONT);

      StdInName : Address = Nil;
      StdOutName: Address = Nil;


      win : NewWindow = (0,0,374,120,-1,-1,
                         GADGETDOWN_f + GADGETUP_f + CLOSEWINDOW_f + RAWKEY_f,
                         WINDOWDRAG + WINDOWDEPTH + WINDOWCLOSE + ACTIVATE,
                         nil,nil,"BorderMaker v1.0",nil,nil,-1,-1,-1,-1,
                         WBENCHSCREEN_f);


      FSOpairs1 : array[1..3,1..2] of short = ((-5,10),(-5,-3),(243,-3));
      FSOpairs2 : array[1..3,1..2] of short = ((-4,9),(-4,-3),(243,-3));
      FSOpairs3 : array[1..3,1..2] of short = ((-4,10),(244,10),(244,-3));
      FSOpairs4 : array[1..3,1..2] of short = ((-4,10),(243,10),(243,-2));

      FSOborder4 : border = (0,0,1,0,JAM2,3,@FSOpairs4,nil);
      FSOborder3 : border = (0,0,1,0,JAM2,3,@FSOpairs3,@FSOborder4);
      FSOborder2 : border = (0,0,2,0,JAM2,3,@FSOpairs2,@FSOborder3);
      FSOborder1 : border = (0,0,2,0,JAM2,3,@FSOpairs1,@FSOborder2);

      FSIpairs1 : array[1..3,1..2] of short = ((-3,9),(-3,-2),(241,-2));
      FSIpairs2 : array[1..3,1..2] of short = ((-2,8),(-2,-2),(241,-2));
      FSIpairs3 : array[1..3,1..2] of short = ((-2,9),(242,9),(242,-2));
      FSIpairs4 : array[1..3,1..2] of short = ((-2,9),(241,9),(241,-1));

      FSIborder4 : border = (0,0,2,0,JAM2,3,@FSIpairs4,@FSOBorder1);
      FSIborder3 : border = (0,0,2,0,JAM2,3,@FSIpairs3,@FSIborder4);
      FSIborder2 : border = (0,0,1,0,JAM2,3,@FSIpairs2,@FSIborder3);
      FSIborder1 : border = (0,0,1,0,JAM2,3,@FSIpairs1,@FSIborder2);


      FInfo : StringInfo = ("\0                                                                                                                                                                                                       ",
                            "\0                                                                                                                                                                                                       ",
                            0,200,0,0,0,0,0,0,nil,0,nil);

      FText0 : intuitext = (1,0,JAM2,-57,-5,@STDFont,"Nom du",nil);
      FText1 : intuitext = (1,0,JAM2,-57,4,@STDFont,"ichier",@FText0);
      FText2 : intuitext = (1,0,JAM2,-65,4,@UDRFont,"F",@FText1);

      F : Gadget = (nil,105,19,242,8,GADGHCOMP,RELVERIFY + GADGIMMEDIATE,
                    STRGADGET,@FSIBorder1,nil,@FText2,0,@FInfo,1,nil);


      SInfo : StringInfo = ("\0                                             ",
                            "\0                                             ",
                            0,46,0,0,0,0,0,0,nil,0,nil);

      SText0 : intuitext = (1,0,JAM2,-81,-5,@STDFont,"Nom de la",nil);
      SText1 : intuitext = (1,0,JAM2,-73,4,@STDFont,"tructure",@SText0);
      SText2 : intuitext = (1,0,JAM2,-81,4,@UDRFont,"S",@SText1);

      S : Gadget = (nil,105,38,242,8,GADGHCOMP,RELVERIFY + GADGIMMEDIATE,
                    STRGADGET,@FSIBorder1,nil,@SText2,0,@SInfo,2,nil);


      LHOpairs1 : array[1..3,1..2] of short = ((-5,10),(-5,-3),(36,-3));
      LHOpairs2 : array[1..3,1..2] of short = ((-4,9),(-4,-3),(36,-3));
      LHOpairs3 : array[1..3,1..2] of short = ((-4,10),(37,10),(37,-3));
      LHOpairs4 : array[1..3,1..2] of short = ((-4,10),(36,10),(36,-2));

      LHOborder4 : border = (0,0,1,0,JAM2,3,@LHOpairs4,nil);
      LHOborder3 : border = (0,0,1,0,JAM2,3,@LHOpairs3,@LHOborder4);
      LHOborder2 : border = (0,0,2,0,JAM2,3,@LHOpairs2,@LHOborder3);
      LHOborder1 : border = (0,0,2,0,JAM2,3,@LHOpairs1,@LHOborder2);

      LHIpairs1 : array[1..3,1..2] of short = ((-3,9),(-3,-2),(34,-2));
      LHIpairs2 : array[1..3,1..2] of short = ((-2,8),(-2,-2),(34,-2));
      LHIpairs3 : array[1..3,1..2] of short = ((-2,9),(35,9),(35,-2));
      LHIpairs4 : array[1..3,1..2] of short = ((-2,9),(34,9),(34,-1));

      LHIborder4 : border = (0,0,2,0,JAM2,3,@LHIpairs4,@LHOBorder1);
      LHIborder3 : border = (0,0,2,0,JAM2,3,@LHIpairs3,@LHIborder4);
      LHIborder2 : border = (0,0,1,0,JAM2,3,@LHIpairs2,@LHIborder3);
      LHIborder1 : border = (0,0,1,0,JAM2,3,@LHIpairs1,@LHIborder2);


      LInfo : StringInfo = ("100\0",
                            "   \0",
                            0,4,0,0,0,0,0,0,nil,100,nil);


      LText0 : intuitext = (1,0,JAM2,-65,0,@STDFont,"ongueur",nil);
      LText  : intuitext = (1,0,JAM2,-73,0,@UDRFont,"L",@LText0);

      L : Gadget = (nil,225,58,32,8,GADGHCOMP,
                    RELVERIFY + GADGIMMEDIATE + LONGINT,
                    STRGADGET,@LHIBorder1,nil,@LText,0,@LInfo,3,nil);


      HInfo : StringInfo = ("100\0",
                            "   \0",
                            0,4,0,0,0,0,0,0,nil,100,nil);

      HText0 : intuitext = (1,0,JAM2,-65,0,@UDRFont,"H",nil);
      HText  : intuitext = (1,0,JAM2,-57,0,@STDFont,"auteur",@HText0);

      H : Gadget = (nil,225,77,32,8,GADGHCOMP,
                    RELVERIFY + GADGIMMEDIATE + LONGINT,
                    STRGADGET,@LHIBorder1,nil,@HText,0,@HInfo,4,nil);



      OText : intuitext = (1,0,JAM2,-62,0,@STDFont,"Offset",nil);
      XText : intuitext = (1,0,JAM2,-14,0,@UDRFont,"X",@OText);
      YText : intuitext = (1,0,JAM2,-14,0,@UDRFont,"Y",@OText);


      XOInfo : StringInfo = ("0\0  ",
                             "   \0",
                             0,4,0,0,0,0,0,0,nil,0,nil);

      XO : Gadget = (nil,327,58,32,8,GADGHCOMP,
                     RELVERIFY + GADGIMMEDIATE + LONGINT,
                     STRGADGET,@LHIBorder1,nil,@XText,0,@XOInfo,5,nil);


      YOInfo : StringInfo = ("0\0  ",
                             "   \0",
                             0,4,0,0,0,0,0,0,nil,0,nil);

      YO : Gadget = (nil,327,77,32,8,GADGHCOMP,
                     RELVERIFY + GADGIMMEDIATE + LONGINT,
                     STRGADGET,@LHIBorder1,nil,@YText,0,@YOInfo,6,nil);


      Tpairs1 : array[1..3,1..2] of short = ((0,13),(0,0),(55,0));
      Tpairs2 : array[1..3,1..2] of short = ((1,12),(1,0),(55,0));
      Tpairs3 : array[1..3,1..2] of short = ((1,13),(56,13),(56,0));
      Tpairs4 : array[1..3,1..2] of short = ((1,13),(55,13),(55,1));

      Tborder4 : border = (0,0,1,0,JAM2,3,@Tpairs4,@Cyclebord1);
      Tborder3 : border = (0,0,1,0,JAM2,3,@Tpairs3,@Tborder4);
      Tborder2 : border = (0,0,2,0,JAM2,3,@Tpairs2,@Tborder3);
      Tborder1 : border = (0,0,2,0,JAM2,3,@Tpairs1,@Tborder2);

      HLTborder4 : border = (0,0,2,0,JAM2,3,@Tpairs4,@Cyclebord1);
      HLTborder3 : border = (0,0,2,0,JAM2,3,@Tpairs3,@HLTborder4);
      HLTborder2 : border = (0,0,1,0,JAM2,3,@Tpairs2,@HLTborder3);
      HLTborder1 : border = (0,0,1,0,JAM2,3,@Tpairs1,@HLTborder2);


      IN1_T  : intuitext = (1,0,JAM2,22,3,@STDFont,"IN1",nil);
      IN2_T  : intuitext = (1,0,JAM2,22,3,@STDFont,"IN2",nil);
      OUT1_T : intuitext = (1,0,JAM2,22,3,@STDFont,"OUT1",nil);
      OUT2_T : intuitext = (1,0,JAM2,22,3,@STDFont,"OUT2",nil);

      CGT4 : CycleGad_Text = (@OUT2_T,4,nil);
      CGT3 : CycleGad_Text = (@OUT1_T,3,@CGT4);
      CGT2 : CycleGad_Text = (@IN2_T,2,@CGT3);
      CGT1 : CycleGad_Text = (@IN1_T,1,@CGT2);


      CGTg : gadget = (nil,92,64,57,14,GADGHIMAGE,RELVERIFY+GADGIMMEDIATE,
                       BOOLGADGET,@Tborder1,@HLTborder1,@IN1_T,0,nil,7,@CGT1);

      TText0 : intuitext = (1,0,JAM2,8,63,@UDRFont,"T",nil);
      TText1 : intuitext = (1,0,JAM2,16,63,@STDFont,"ype de la",@TText0);
      TText2 : intuitext = (1,0,JAM2,16,72,@STDFont,"Structure",@TText1);


      Epairs1 : array[1..3,1..2] of short = ((0,13),(0,0),(94,0));
      Epairs2 : array[1..3,1..2] of short = ((1,12),(1,0),(94,0));
      Epairs3 : array[1..3,1..2] of short = ((1,13),(95,13),(95,0));
      Epairs4 : array[1..3,1..2] of short = ((1,13),(94,13),(94,1));

      Eborder4 : border = (0,0,1,0,JAM2,3,@Epairs4,nil);
      Eborder3 : border = (0,0,1,0,JAM2,3,@Epairs3,@Eborder4);
      Eborder2 : border = (0,0,2,0,JAM2,3,@Epairs2,@Eborder3);
      Eborder1 : border = (0,0,2,0,JAM2,3,@Epairs1,@Eborder2);

      Ehlborder4 : border = (0,0,2,0,JAM2,3,@Epairs4,nil);
      Ehlborder3 : border = (0,0,2,0,JAM2,3,@Epairs3,@Ehlborder4);
      Ehlborder2 : border = (0,0,1,0,JAM2,3,@Epairs2,@Ehlborder3);
      Ehlborder1 : border = (0,0,1,0,JAM2,3,@Epairs1,@Ehlborder2);


      EText0 : intuitext = (1,0,JAM2,25,3,@UDRFont,"E",nil);
      EText  : intuitext = (1,0,JAM2,33,3,@STDFont,"crire",@EText0);

      E : gadget = (nil,40,93,96,14,GADGHIMAGE,RELVERIFY+GADGIMMEDIATE,
                    BOOLGADGET,@Eborder1,@Ehlborder1,@EText,0,nil,8,nil);


      CText0 : intuitext = (1,0,JAM2,9,3,@UDRFont,"C",nil);
      CText  : intuitext = (1,0,JAM2,17,3,@STDFont,"omplement",@CText0);

      C : gadget = (nil,228,93,96,14,GADGHIMAGE,RELVERIFY+GADGIMMEDIATE,
                    BOOLGADGET,@Eborder1,@Ehlborder1,@CText,0,nil,9,nil);


      strpairs : array[1..3,1..2] of string =
            ( (",","),(") , (",","),(") , (",","));"));

      deb : string = "    ";


   Derr_1 : intuitext = (0,1,JAM2,32,10,@STDFont,"Erreur systme numro",nil);
   Derr_2 : intuitext = (0,1,JAM2,102,20,@STDFont,"",@Derr_1);

 Quit_1 : intuitext = (0,1,JAM2,32,10,@STDFont,"Etes-vous sr de vouloir",nil);
 Quit_2 : intuitext = (0,1,JAM2,52,20,@STDFont,"quitter BorderMaker",@Quit_1);

      Okay : intuitext = (0,1,JAM2,6,3,@STDFont,"Continuer",nil);
      OhNo : intuitext = (0,1,JAM2,6,3,@STDFont,"Oh non",nil);

VAR
   w    : windowptr;
   im   : intuimessageptr;
   quit,
   ok   : boolean;
   mode : integer;

PROCEDURE Ecrire;

VAR
   fh       : filehandle;
   derr,i,j,
   k,front  : integer;
   s        : string;
   ok       : boolean;
   t        : array[1..4,1..3,1..2] of short;

  PROCEDURE compose_tab(x,y : integer);

  BEGIN

      t[1,1,1] := xoinfo.longint + x;
      t[1,1,2] := yoinfo.longint + hinfo.longint - y;

      t[1,2,1] := xoinfo.longint + x;
      t[1,2,2] := yoinfo.longint + y;

      t[1,3,1] := xoinfo.longint + linfo.longint - 1 - x;
      t[1,3,2] := yoinfo.longint + y;

      t[2,1,1] := xoinfo.longint + 1 + x;
      t[2,1,2] := yoinfo.longint + hinfo.longint - 1 - y;

      t[2,2,1] := xoinfo.longint + 1 + x;
      t[2,2,2] := yoinfo.longint + y;

      t[2,3,1] := xoinfo.longint + linfo.longint - 1 - x;
      t[2,3,2] := yoinfo.longint + y;

      t[3,1,1] := xoinfo.longint + 1 + x;
      t[3,1,2] := yoinfo.longint + hinfo.longint - y;

      t[3,2,1] := xoinfo.longint + linfo.longint - x;
      t[3,2,2] := yoinfo.longint + hinfo.longint - y;

      t[3,3,1] := xoinfo.longint + linfo.longint - x;
      t[3,3,2] := yoinfo.longint + y;

      t[4,1,1] := xoinfo.longint + 1 + x;
      t[4,1,2] := yoinfo.longint + hinfo.longint - y;

      t[4,2,1] := xoinfo.longint + linfo.longint - 1 - x;
      t[4,2,2] := yoinfo.longint + hinfo.longint - y;

      t[4,3,1] := xoinfo.longint + linfo.longint - 1 - x;
      t[4,3,2] := yoinfo.longint + 1 + y;

   END;

BEGIN

   s := allocstring(10);
   deb[0] := chr(10);
   derr := 0;
   fh := dosopen(FInfo.buffer,MODE_NEWFILE);
   IF fh=nil THEN
      derr := ioerr;
   IF derr=0 THEN
   BEGIN
      compose_tab(0,0);
      FOR k := 1 TO 4 DO
      BEGIN
         derr := doswrite(fh,deb,4);
         derr := doswrite(fh,SInfo.buffer,strlen(SInfo.buffer));
         derr := doswrite(fh,"Pairs",5);
         derr := inttostr(s,k);
         derr := doswrite(fh,s,1);
         derr := doswrite(fh," :array[1..3,1..2] of short = ((",32);
         FOR i := 1 TO 3 DO
            FOR j := 1 TO 2 DO
            BEGIN
               derr := inttostr(s,t[k,i,j]);
               derr := doswrite(fh,s,strlen(s));
               derr := doswrite(fh,strpairs[i,j],strlen(strpairs[i,j]));
            END;
      END;

      derr := doswrite(fh,deb,1);

      IF ( (mode = 2) OR (mode = 4) ) THEN
      BEGIN
         compose_tab(2,1);
         FOR k := 1 TO 4 DO
         BEGIN
            derr := doswrite(fh,deb,4);
            derr := doswrite(fh,SInfo.buffer,strlen(SInfo.buffer));
            derr := doswrite(fh,"Pairs",5);
            derr := doswrite(fh,"In",2);
            derr := inttostr(s,k);
            derr := doswrite(fh,s,1);
            derr := doswrite(fh," :array[1..3,1..2] of short = ((",32);
            FOR i := 1 TO 3 DO
               FOR j := 1 TO 2 DO
               BEGIN
                  derr := inttostr(s,t[k,i,j]);
                  derr := doswrite(fh,s,strlen(s));
                  derr := doswrite(fh,strpairs[i,j],strlen(strpairs[i,j]));
               END;
         END;

         derr := doswrite(fh,deb,1);

         FOR i := 4 DOWNTO 1 DO
         BEGIN
            IF (
               ((i = 4) AND (mode = 4))
               OR
               ((i = 2) AND (mode = 2))
               )
            THEN
               front := 1
            ELSE
            IF (
               ((i = 4) AND (mode = 2))
               OR
               ((i = 2) AND (mode = 4))
               )
            THEN
               front := 2;
            derr := doswrite(fh,deb,4);
            derr := doswrite(fh,SInfo.buffer,strlen(SInfo.buffer));
            derr := doswrite(fh,"Border",6);
            derr := doswrite(fh,"In",2);
            derr := inttostr(s,i);
            derr := doswrite(fh,s,derr);
            derr := doswrite(fh," : border = (0,0,",17);
            derr := inttostr(s,front);
            derr := doswrite(fh,s,derr);
            derr := doswrite(fh,",0",2);
            derr := doswrite(fh,",JAM2,3,@",9);
            derr := doswrite(fh,SInfo.buffer,strlen(SInfo.buffer));
            derr := doswrite(fh,"pairs",5);
            derr := doswrite(fh,"In",2);
            derr := inttostr(s,i);
            derr := doswrite(fh,s,derr);
            derr := doswrite(fh,",",1);
            IF i=4 THEN
               derr := doswrite(fh,"nil",3)
            ELSE
            BEGIN
               derr := doswrite(fh,"@",1);
               derr := doswrite(fh,SInfo.buffer,strlen(SInfo.buffer));
               derr := doswrite(fh,"BorderIn",8);
               derr := inttostr(s,i+1);
               derr := doswrite(fh,s,derr);
            END;
            derr := doswrite(fh,");",2);
         END;
         derr := doswrite(fh,deb,1);
      END;

      FOR i := 4 DOWNTO 1 DO
      BEGIN
         IF (
            ( (i = 4) AND ((mode = 3) OR (mode=2)) )
            OR
            ( (i = 2) AND ((mode = 1) OR (mode=4)) )
            )
         THEN
            front := 1
         ELSE
         IF (
            ( (i = 4) AND ((mode = 1) OR (mode=4)) )
            OR
            ( (i = 2) AND ((mode = 2) OR (mode=3)) )
            )
         THEN
            front := 2;
         derr := doswrite(fh,deb,4);
         derr := doswrite(fh,SInfo.buffer,strlen(SInfo.buffer));
         derr := doswrite(fh,"Border",6);
         derr := inttostr(s,i);
         derr := doswrite(fh,s,derr);
         derr := doswrite(fh," : border = (0,0,",17);
         derr := inttostr(s,front);
         derr := doswrite(fh,s,derr);
         derr := doswrite(fh,",0",2);
         derr := doswrite(fh,",JAM2,3,@",9);
         derr := doswrite(fh,SInfo.buffer,strlen(SInfo.buffer));
         derr := doswrite(fh,"pairs",5);
         derr := inttostr(s,i);
         derr := doswrite(fh,s,derr);
         derr := doswrite(fh,",",1);
         IF (
            (i = 4)
            AND
            ((mode = 1) OR (mode = 3))
            )
         THEN
           derr := doswrite(fh,"nil",3)
         ELSE
         IF (
            (i = 4)
            AND
            ((mode = 2) OR (mode = 4))
            )
         THEN
         BEGIN
            derr := doswrite(fh,"@",1);
            derr := doswrite(fh,SInfo.buffer,strlen(SInfo.buffer));
            derr := doswrite(fh,"BorderIn",8);
            derr := inttostr(s,1);
            derr := doswrite(fh,s,derr);
         END
         ELSE
         BEGIN
            derr := doswrite(fh,"@",1);
            derr := doswrite(fh,SInfo.buffer,strlen(SInfo.buffer));
            derr := doswrite(fh,"Border",6);
            derr := inttostr(s,i+1);
            derr := doswrite(fh,s,derr);
         END;
         derr := doswrite(fh,");",2);
      END;

      IF C.flags = GADGHIMAGE + SELECTED THEN
      BEGIN
         derr := doswrite(fh,deb,1);
         FOR i := 4 DOWNTO 1 DO
         BEGIN
            IF (
               ( (i = 4) AND (mode = 1) )
               OR
               ( (i = 2) AND (mode = 3) )
               )
            THEN
               front := 1
            ELSE
            IF (
               ( (i = 4) AND (mode = 3) )
               OR
               ( (i = 2) AND (mode = 1) )
               )
            THEN
               front := 2;
            derr := doswrite(fh,deb,4);
            derr := doswrite(fh,SInfo.buffer,strlen(SInfo.buffer));
            derr := doswrite(fh,"Border",6);
            derr := doswrite(fh,"HL",2);
            derr := inttostr(s,i);
            derr := doswrite(fh,s,derr);
            derr := doswrite(fh," : border = (0,0,",17);
            derr := inttostr(s,front);
            derr := doswrite(fh,s,derr);
            derr := doswrite(fh,",0",2);
            derr := doswrite(fh,",JAM2,3,@",9);
            derr := doswrite(fh,SInfo.buffer,strlen(SInfo.buffer));
            derr := doswrite(fh,"pairs",5);
            derr := inttostr(s,i);
            derr := doswrite(fh,s,derr);
            derr := doswrite(fh,",",1);
            IF
               (i = 4)
            THEN
              derr := doswrite(fh,"nil",3)
            ELSE
            BEGIN
               derr := doswrite(fh,"@",1);
               derr := doswrite(fh,SInfo.buffer,strlen(SInfo.buffer));
               derr := doswrite(fh,"BorderHL",8);
               derr := inttostr(s,i+1);
               derr := doswrite(fh,s,derr);
            END;
            derr := doswrite(fh,");",2);
         END;
      END;

      dosclose(fh);
   END
   ELSE
   BEGIN
      derr := inttostr(s,derr);
      Derr_2.IText := strdup(s);
      ok := AutoRequest(w,@Derr_2,@Okay,@Okay,reqgadget,reqgadget,252,70);
   END;
   freestring(s);
END;

PROCEDURE ouvre_tout;

BEGIN
   w := openwindow(@win);
   quit := false;

   CGT4.next := @CGT1;

   if addgadget(w,@S,-1) = 0 then;
   if addgadget(w,@F,-1) = 0 then;
   if addgadget(w,@CGTg,-1) = 0 then;
   if addgadget(w,@L,-1) = 0 then;
   if addgadget(w,@H,-1) = 0 then;
   if addgadget(w,@XO,-1) = 0 then;
   if addgadget(w,@YO,-1) = 0 then;
   if addgadget(w,@E,-1) = 0 then;
   if addgadget(w,@C,-1) = 0 then;

   refreshgadgets(w^.firstgadget,w,nil);

   printitext(w^.rport,@TText2,0,0);

   mode := 1;

END;

PROCEDURE ChgTyp;
BEGIN
   CG_CycleText(CGTg,w);
   mode := CG_GetId(CGTg);
   IF ((mode = 2) OR (mode = 4)) THEN
      IF (C.flags = GADGHIMAGE + SELECTED) THEN
      BEGIN
         C.flags := GADGHIMAGE;
         refreshgadgets(@C,w,nil);
      END;
END;


PROCEDURE Complemente;
BEGIN

   mode := CG_GetId(CGTg);
   IF ((mode = 1) OR (mode = 3)) THEN
      IF C.flags = GADGHIMAGE THEN
         C.flags := GADGHIMAGE + SELECTED
      ELSE
         C.flags := GADGHIMAGE;
END;


BEGIN

   ouvre_tout;

   REPEAT
      im := intuimessageptr(waitport(w^.userport));
      im := intuimessageptr(getmsg(w^.userport));

      CASE im^.class OF
         CLOSEWINDOW_f :

         quit := AutoRequest(w,@Quit_2,@Okay,@OhNo,reqgadget,reqgadget,274,70);

         GADGETUP_f     :  BEGIN

                              CASE gadgetptr(im^.iaddress)^.gadgetid of

                                 7  :  ChgTyp;

                                 1  :  ok := activategadget(@S,w,nil);

                                 2  :  ok := activategadget(@L,w,nil);

                                 3  :  ok := activategadget(@XO,w,nil);

                                 5  :  ok := activategadget(@H,w,nil);

                                 4  :  ok := activategadget(@YO,w,nil);

                              END;

                           END;

         GADGETDOWN_F   :  BEGIN

                              CASE gadgetptr(im^.iaddress)^.gadgetid OF

                                 8  :  Ecrire;

                                 9  :  Complemente;

                              END;

                           END;

         RAWKEY_f       :  BEGIN

                              CASE im^.code of

                                 18 :  Ecrire;

                                 20 :  ChgTyp;

                                 51 :  BEGIN
                                          Complemente;
                                          refreshgadgets(@C,w,nil);
                                       END;

                                 40 :  ok := activategadget(@L,w,nil);

                                 37 :  ok := activategadget(@H,w,nil);

                                 50 :  ok := activategadget(@XO,w,nil);

                                 21 :  ok := activategadget(@YO,w,nil);

                                 33 :  ok := activategadget(@S,w,nil);

                                 35 :  ok := activategadget(@F,w,nil);

                                 69 :
         quit := AutoRequest(w,@Quit_2,@Okay,@OhNo,reqgadget,reqgadget,274,70);
                              END;
                           END;
      END;

      replymsg(messageptr(im));
   UNTIL quit;
   closewindow(w);
END.
